<?php
namespace Fiscal\Repositories;

class Itemproimpos extends \Doctrine\ORM\EntityRepository
{
    public function consultaItemProdutoImpostoNFE($cdfilial, $nrlanctonf, $cdimpostonfe, $nrorg)
    {
        $sql = <<<SQL
        SELECT ITEMPROIMPOS.CDFILIAL,
          ITEMPROIMPOS.NRLANCTONF,
          ITEMPROIMPOS.CDIMPOSTO,
          IMPOSTO.CDIMPOSTONFE
          FROM ITEMPROIMPOS
          JOIN IMPOSTO
            ON ITEMPROIMPOS.CDIMPOSTO = IMPOSTO.CDIMPOSTO
            AND ITEMPROIMPOS.NRORG    = IMPOSTO.NRORG
        WHERE
         ITEMPROIMPOS.CDFILIAL    = :CDFILIAL
        AND ITEMPROIMPOS.NRLANCTONF  = :NRLANCTONF
        AND IMPOSTO.CDIMPOSTONFE     = :CDIMPOSTONFE
        AND IMPOSTO.NRORG            = :NRORG
SQL;
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "CDIMPOSTONFE" => $cdimpostonfe,
            "NRORG" => $nrorg
        );

        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
    }

    public function consultaDadosImpostosNFE($cdfilial, $nrlanctonf, $nrseqitprod)
    {
        $sql = <<<SQL
        SELECT IP.CDIMPOSTONFE AS CDIMPOSTONFE,
               IT.CDFISCALIT,
               IT.NRORG,
               IT.CDIMPOSTO,
               IT.VRPERREDBCIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99'))) AS VALORIMPOSTO,
               IT.VRIMPOSTOIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.9999')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.9999'))) AS VALORIMPOSTOALIQ,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99'))) AS BASECALCULO,
               IT.VRBASECALCIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRPERREDBCIT, 2), '999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRPERREDBCIT, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRPERREDBCIT, 2), '999.99'))) AS PERCENTUALRED,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM, 2), '999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM, 2), '999.99'))) AS ALIQUOTA,
               SUBSTR(IT.CDSITUTRIBIT, 1, 1) as ORIGEM, IT.CDSITUTRIBITNFE as CST,
               IP.CDIMPOSTRIB,
               IT.IDMODBCITNFE,
               IT.IDMODBCSTITNFE,
               IT.CDSITUTRIBIT,
               IP.CDTRIBISSQN,
               NVL(IT.IDIMPDESONERAIT, 'N') AS IDIMPDESONERAIT,
               IT.IDMOTDESONERAIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRBCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRBCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRBCICMSSTRETIDO, 2), '9999999999999.99'))) AS BASECALCULORETIDO,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRICMSSTRETIDO, 2), '9999999999999.99'))) AS VALORIMPOSTORETIDO,
               SUBSTR(I.CDFISCOPERSN, 1, 1) as ORIGEMSN
          FROM ITEMPROIMPOS IT, IMPOSTO IP, ITEMPRODUTO I
         WHERE IT.CDIMPOSTO = IP.CDIMPOSTO
           AND IT.NRORG     = IP.NRORG
           AND IT.CDFILIAL = :CDFILIAL
           AND IT.NRLANCTONF = :NRLANCTONF
           AND IT.NRSEQITPROD = :NRSEQITPROD
           AND IT.NRITPROIMPOS = '1'
           AND IT.CDFILIAL = I.CDFILIAL
           AND IT.NRLANCTONF = I.NRLANCTONF
           AND IT.NRSEQITPROD = I.NRSEQITPROD
           AND IT.NRORG       = I.NRORG
SQL;
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRSEQITPROD" => $nrseqitprod
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function consultaDesoneraItem($cdfilial, $nrlanctonf, $nrseqitprod)
    {
        $sql = <<<SQL
        SELECT CDFILIAL, NRLANCTONF, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(SUM(VRIMPOSTOIT), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(SUM(VRIMPOSTOIT), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(SUM(VRIMPOSTOIT), 2), '9999999999999.99'))) AS VALORDESONERA
          FROM ITEMPROIMPOS
         WHERE CDFILIAL = :CDFILIAL
           AND NRLANCTONF = :NRLANCTONF
           AND ((NRSEQITPROD = :NRSEQITPROD) OR (:NRSEQITPROD = 'T'))
           AND NRITPROIMPOS = '1'
           AND IDIMPDESONERAIT = 'S'
         GROUP BY CDFILIAL, NRLANCTONF
SQL;
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRSEQITPROD" => $nrseqitprod
        );

        try{
            return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function consultaImpostosItemNotaDevolucao($filial, $lancamento, $codigoProduto, $nrLote, $nrSubLote, $vrUnitario){
    	$sql = <<<SQL
        SELECT I.CDPRODUTO, A.CDIMPOSTO, B.SGIMPOSTO, B.IDTRATIMPO,
		       A.CDFISCALIT, A.VRALIQITEM AS VRALIQUOTA, A.VRPERREDBCIT, SUM(A.VRIMPOSTOIT) VRIMPOSTOIT,
		       SUM(A.VRCONTITIMP) VRCONTITIMP, SUM(A.VRBASECALCIT) VRBASECALCIT, A.VRPARDEDIT, CDALMOXARIFE,
		       CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, VR1PERREDBCIT, VR1IMPREDBCIT, A.IDTRIMPSTII,
		       A.CDSITUTRIBIT, A.CDFISCOPERIT, A.CDSUFXCFOPIT, A.CDSITUTRIBITNFE, A.IDMODBCITNFE,
		       A.IDMODBCSTITNFE, A.CDTPCREDPICOITE, A.CDNATUBCALPCIT
		  FROM ITEMPROIMPOS A, IMPOSTO B, ITEMPRODUTO I
		 WHERE I.CDFILIAL = :CDFILIAL
		   AND I.NRLANCTONF = :NRLANCTONF
		   AND I.CDPRODUTO = :P_CDPRODUTO
		   AND NVL(I.NRLOTEESTQ, ' ') = NVL(:P_NRLOTEESTQ, ' ')
		   AND NVL(I.NRSUBLOTE, ' ') = NVL(:P_NRSUBLOTE, ' ')
		   AND ROUND(I.VRUNITITEM,2) = ROUND(:VRUNITITEM,2)
		   AND A.CDFILIAL = I.CDFILIAL
		   AND A.NRLANCTONF = I.NRLANCTONF
		   AND A.NRSEQITPROD = I.NRSEQITPROD
		   AND A.NRITPROIMPOS <> '3'
		   AND A.CDIMPOSTO = B.CDIMPOSTO
		 GROUP BY I.CDPRODUTO, A.CDIMPOSTO, B.SGIMPOSTO, B.IDTRATIMPO,
		          A.CDFISCALIT, A.VRALIQITEM, A.VRPARDEDIT, A.VRPERREDBCIT,
		          CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, VR1PERREDBCIT, VR1IMPREDBCIT, A.IDTRIMPSTII,
		          A.CDSITUTRIBIT, A.CDFISCOPERIT, A.CDSUFXCFOPIT, A.CDSITUTRIBITNFE, A.IDMODBCITNFE,
		          A.IDMODBCSTITNFE, A.CDTPCREDPICOITE, A.CDNATUBCALPCIT
		 ORDER BY 1, 2, 3, 4, 5
SQL;
    	$params = array(
    			"CDFILIAL" => $filial,
    			"NRLANCTONF" => $lancamento,
    			"P_CDPRODUTO" => $codigoProduto,
    			"P_NRLOTEESTQ" => $nrLote,
    			"P_NRSUBLOTE" => $nrSubLote,
    			"VRUNITITEM" => $vrUnitario
    	);
    	
    	try{
    		return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
    	} catch (\Exception $e) {
    		throw $e;
    	}
    }

    /**
     * @param $cdfilial
     * @param $nrlanctonf
     * @param $nrseqitprod
     * @param $nrorg
     * @return void
     * @throws \Exception
     */
    public function consultaImpostosItem($cdfilial, $nrlanctonf, $nrseqitprod, $nrorg){
        $sql = <<<SQL
        SELECT IT.CDFILIAL,
               IT.NRLANCTONF,
               IT.NRORG,
               IT.NRSEQITPROD,
               IT.CDIMPOSTO,
               IP.CDIMPOSTONFE,
               IP.CDIMPOSTRIB,
               IT.VRBASECALCIT,
               IT.VRIMPOSTOIT,
               IT.CDFISCALIT,
               IT.CDSITUTRIBIT,
               IT.CDSITUTRIBITNFE AS CST,
               IT.IDMODBCITNFE,
               IP.CDTRIBISSQN,
               IT.IDMODBCSTITNFE,
               IT.IDIMPDESONERAIT,
               IT.IDMOTDESONERAIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99'))) AS BASECALCULO,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99'))) AS VALORIMPOSTO
          FROM ITEMPROIMPOS IT, IMPOSTO IP
         WHERE IT.CDIMPOSTO = IP.CDIMPOSTO
           AND IT.NRORG     = IP.NRORG
           AND IT.CDFILIAL = :P_CDFILIAL
           AND IT.NRLANCTONF = :P_NRLANCTONF
           AND IT.NRSEQITPROD = :P_NRSEQITPROD
           AND IT.NRORG       = :P_NRORG
           AND IT.NRITPROIMPOS = '1'
SQL;
        $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRSEQITPROD" => $nrseqitprod,
            "P_NRORG" => $nrorg
        );

        try{
            return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function verificaCST($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        SELECT NVL(CDSITUTRIBIT, 'XXX') CDSITUTRIBIT
          FROM ITEMPROIMPOS
         WHERE CDFILIAL   = :P_CDFILIAL   AND
               NRLANCTONF = :P_NRLANCTONF AND
               NRORG      = :P_NRORG
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function verificaCSTit($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        SELECT CDSITUTRIBPR
          FROM ITEMPRODUTO
         WHERE CDFILIAL = :P_CDFILIAL     AND
               NRLANCTONF = :P_NRLANCTONF AND
               NRORG      = :P_NRORG      AND
               CDSITUTRIBPR IS NULL
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function verificaCFOP($cdfilial, $nrlanctonf, $nrorg) {
    $sql = <<<SQL
        SELECT NVL(CDFISCOPERIT, 'XXX') CDFISCOPERIT
          FROM ITEMPROIMPOS
         WHERE CDFILIAL   = :P_CDFILIAL   AND
               NRLANCTONF = :P_NRLANCTONF AND
               NRORG      = :P_NRORG
SQL;

    $params = array(
        'P_CDFILIAL'      => $cdfilial,
        'P_NRLANCTONF'   => $nrlanctonf,
        'P_NRORG'      => $nrorg
    );

    return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
}

    public function verificaCFOPit($cdfilial, $nrlanctonf, $nrorg) {
        $sql = <<<SQL
        SELECT CDFISOPEITEM
          FROM ITEMPRODUTO
         WHERE CDFILIAL   = :P_CDFILIAL   AND
               NRLANCTONF = :P_NRLANCTONF AND
               NRORG      = :P_NRORG      AND
               CDFISOPEITEM IS NULL
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
    }


}