create or replace 
PROCEDURE ETL_ORDPRODUCAO
                        (P_DTINI IN DATE,
                         P_DTFINA IN DATE)
IS
V_COUNTER  NUMBER       NOT NULL := 0;
BEGIN

   FOR C_DATA IN(SELECT *
                   FROM (SELECT TO_CHAR(DTMES, 'YYYY') CDANOBI,
                                TO_CHAR(DTMES, 'MM') CDMESBI,
                                TO_CHAR(DTMES, 'DD/MM/YYYY') DTINI,
                                TO_CHAR(LAST_DAY(DTMES), 'DD/MM/YYYY') DTFIM
                           FROM DATA
                          WHERE DTMES BETWEEN P_DTINI AND P_DTFINA
                          GROUP BY DTMES
                          ORDER BY DTMES)
                  ORDER BY CDANOBI, CDMESBI)LOOP

    FOR C_FILIAL IN (SELECT FILIAL.CDFILIAL,
                            FILIAL.CDEMPRESA,
                            FILIAL.CDFILIAL||'-'||FILIAL.NMFILIAL DSFILIAL,
                            PARAMAN.NRTPCUSTOOP
                       FROM FILIAL, PARAMAN
                      WHERE FILIAL.CDFILIAL = PARAMAN.CDFILIAL
                      ORDER BY FILIAL.CDFILIAL)LOOP

    -->>DELEO DOS DADOS
    FOR C_DEL IN (SELECT ROWID REG_DEL
                    FROM DM_PROCFABPROD
                   WHERE (SUBSTR(DSFILIAL,0,4) = C_FILIAL.CDFILIAL)
                     AND (CDANOBI = C_DATA.CDANOBI)
                     AND (CDMESBI = C_DATA.CDMESBI))LOOP

    V_COUNTER := V_COUNTER +1;

    DELETE
      FROM DM_PROCFABPROD
     WHERE C_DEL.REG_DEL = ROWID;

    IF V_COUNTER >= 1000 THEN
       COMMIT;
       V_COUNTER := 0;
    END IF;

    END LOOP;

  COMMIT;

  V_COUNTER := 0;

      FOR C_ORDPROD IN(SELECT ORDPRODUCAO.CDFILIAL,
                              ORDPRODUCAO.NRORDPROD,
                              ORDPRODUCAO.NRSUBORDPROD,
                              ORDPRODUCAO.NRORDPROD || '\-' || ORDPRODUCAO.NRSUBORDPROD DSORDPROD,
                              ORDPRODUCAO.CDPRODUTO,
                              PRODUTO.NMPRODUTO||' - '||PRODUTO.SGUNIDADE DSPRODUTO,
                              ORDPRODUCAO.CDPROCFABRIC,
                              TPROCFABRICA.NMPROCFABRIC,
                              CUSTOINDI.CDFUNCUSTO,
                              FUNCUSTO.NMFUNCUSTO,
                              CUSTOINDI.CDCUSTOINDI,
                              CUSTOINDI.NMCUSTOINDI,
                              ETAPAPROD.CDETAPAPROD,
                              ETAPAPROD.NMETAPAPROD,
                              ORDPRODUCAO.QTAPRODPREOP,
                              (CASE ORDPRODUCAO.IDSITORDPROD WHEN '1' THEN 'Pendente'
                                                             WHEN '2' THEN 'Em Andamento'
                                                             WHEN '3' THEN 'Concluda'
                                                             WHEN '4' THEN 'Cancelada'
                                                             WHEN '5' THEN 'Reprovada'
                                                             ELSE 'N/E' END) DSSITORDPROD
                         FROM ORDPRODUCAO, PRODUTO, FUNCUSTO,
                              ETAPAPROD, CUSTOINDI, TPROCFABRICA
                        WHERE (ORDPRODUCAO.CDFILIAL     = C_FILIAL.CDFILIAL)
                          AND (DECODE(ORDPRODUCAO.IDSITORDPROD,'3',(TO_DATE(ORDPRODUCAO.DTHRFIMREAOP)),(TO_DATE(ORDPRODUCAO.DTHRINIPREOP))) BETWEEN C_DATA.DTINI AND C_DATA.DTFIM)
                          AND (ORDPRODUCAO.CDPRODUTO    = PRODUTO.CDPRODUTO)
                          AND (ETAPAPROD.CDETAPAPROD IN ((SELECT CDETAPAPROD
                                                            FROM ETAFABRIC
                                                           WHERE (CDFILIAL     = ORDPRODUCAO.CDFILIAL)
                                                             AND (CDPRODUTO    = ORDPRODUCAO.CDPRODUTO)
                                                             AND (CDPROCFABRIC = ORDPRODUCAO.CDPROCFABRIC)
                                                           UNION
                                                          SELECT CDETAPAPROD
                                                            FROM ETAFABRICOP
                                                           WHERE (CDFILIAL     = ORDPRODUCAO.CDFILIAL)
                                                             AND (NRORDPROD    = ORDPRODUCAO.NRORDPROD)
                                                             AND (NRSUBORDPROD = ORDPRODUCAO.NRSUBORDPROD))))
                          AND (CUSTOINDI.IDCOMPCUSTPR  = 'S')
                          AND (TPROCFABRICA.CDPROCFABRIC = ORDPRODUCAO.CDPROCFABRIC)
                          AND (FUNCUSTO.CDFUNCUSTO = CUSTOINDI.CDFUNCUSTO)
                        ORDER BY ORDPRODUCAO.NRORDPROD, ORDPRODUCAO.NRSUBORDPROD, CUSTOINDI.CDCUSTOINDI, ETAPAPROD.CDETAPAPROD
                       )LOOP

         FOR C_CUSTO IN (SELECT DADOS.CDAPRCUSTO,
                                DADOS.NMAPRCUSTO,
                                NVL(PLAN.CUSTUNIT,0) AS CUSTUNIT,
                                NVL(PLAN.QTDE,0) AS QTDEPLAN,
                                NVL(PLAN.VRCUSTPLAN,0) AS VRCUSTPLAN,
                                NVL(REAL.QTDE,0) AS QTDEREAL,
                                NVL(REAL.VRCUSTREAL,0) AS VRCUSTREAL
                           FROM (SELECT DISTINCT I.CDPRODINSUMO AS CDAPRCUSTO,
                                                 NMPRODUTO AS NMAPRCUSTO
                                   FROM INSUMETAPA I, PRODUTO P
                                  WHERE (I.CDFILIAL   = C_FILIAL.CDFILIAL)
                                    AND (I.CDPRODUTO    = C_ORDPROD.CDPRODUTO)
                                    AND (I.CDPROCFABRIC = C_ORDPROD.CDPROCFABRIC)
                                    AND (I.CDETAPAPROD  = C_ORDPROD.CDETAPAPROD)
                                    AND (I.CDPRODINSUMO = P.CDPRODUTO)
                                    AND (C_ORDPROD.CDFUNCUSTO    = '001')
                                  UNION
                                 SELECT DISTINCT R.CDHABILIDADE AS CDAPRCUSTO,
                                                 H.NMHABILIDADE AS NMAPRCUSTO
                                   FROM RECURETAPA R, HABILIDADE H
                                  WHERE (R.CDFILIAL   = C_FILIAL.CDFILIAL)
                                    AND (R.CDPRODUTO    = C_ORDPROD.CDPRODUTO)
                                    AND (R.CDPROCFABRIC = C_ORDPROD.CDPROCFABRIC)
                                    AND (R.CDETAPAPROD  = C_ORDPROD.CDETAPAPROD)
                                    AND (R.IDRECURETAPA = 'H')
                                    AND (R.CDHABILIDADE = H.CDHABILIDADE)
                                    AND (C_ORDPROD.CDFUNCUSTO   = '002')
                                  UNION
                                 SELECT DISTINCT R.CDEQUIPPRO AS CDAPRCUSTO,
                                                 NMEQUIPPRO   AS NMAPRCUSTO
                                   FROM RECURETAPA R, EQUIPAPROD E
                                  WHERE (R.CDFILIAL   = C_FILIAL.CDFILIAL)
                                    AND (R.CDPRODUTO    = C_ORDPROD.CDPRODUTO)
                                    AND (R.CDPROCFABRIC = C_ORDPROD.CDPROCFABRIC)
                                    AND (R.CDETAPAPROD  = C_ORDPROD.CDETAPAPROD)
                                    AND (R.IDRECURETAPA = 'E')
                                    AND (R.CDEQUIPPRO   = E.CDEQUIPPRO)
                                    AND (C_ORDPROD.CDFUNCUSTO    = '003')
                                  UNION
                                 SELECT DISTINCT I.CDINSPECAO AS CDAPRCUSTO,
                                                 INSP.NMINSPECAO AS NMAPRCUSTO
                                   FROM INSPECAO INSP, INSPETAPA I
                                  WHERE (I.CDFILIAL        = C_FILIAL.CDFILIAL)
                                    AND (I.CDPRODUTO       = C_ORDPROD.CDPRODUTO)
                                    AND (I.CDPROCFABRIC    = C_ORDPROD.CDPROCFABRIC)
                                    AND (I.CDETAPAPROD     = C_ORDPROD.CDETAPAPROD)
                                    AND (I.CDINSPECAO      = INSP.CDINSPECAO)
                                    AND (INSP.IDORIGINSPEC = 'ANA')
                                    AND (C_ORDPROD.CDFUNCUSTO      = '004')
                                  UNION
                                 SELECT DISTINCT I.CDINSPECAO AS CDAPRCUSTO,
                                                 INSP.NMINSPECAO AS NMAPRCUSTO
                                   FROM INSPECAO INSP, INSPETAPA I
                                  WHERE (I.CDFILIAL        = C_FILIAL.CDFILIAL)
                                    AND (I.CDPRODUTO       = C_ORDPROD.CDPRODUTO)
                                    AND (I.CDPROCFABRIC    = C_ORDPROD.CDPROCFABRIC)
                                    AND (I.CDETAPAPROD     = C_ORDPROD.CDETAPAPROD)
                                    AND (I.CDINSPECAO      = INSP.CDINSPECAO)
                                    AND (INSP.IDORIGINSPEC = 'QUA')
                                    AND (C_ORDPROD.CDFUNCUSTO       = '005')
                                  UNION
                                 SELECT DISTINCT A.CDAPRCUSTOP AS CDAPRCUSTO,
                                                 NMAPRCUSTOP   AS NMAPRCUSTO
                                   FROM APRCUSTOP A
                                  WHERE (A.CDFILIAL     = C_FILIAL.CDFILIAL)
                                    AND (A.NRORDPROD    = C_ORDPROD.NRORDPROD)
                                    AND (A.NRSUBORDPROD = C_ORDPROD.NRSUBORDPROD)
                                    AND (A.CDETAPAPROD  = C_ORDPROD.CDETAPAPROD)
                                    AND (A.CDCUSTOINDI  = C_ORDPROD.CDCUSTOINDI)) DADOS,

                                 (SELECT I.CDPRODINSUMO AS CDAPRCUSTO,
                                         CUSTO_PRODUTO(C_FILIAL.CDFILIAL, I.CDPRODINSUMO, C_FILIAL.NRTPCUSTOOP, SYSDATE, SYSDATE) AS CUSTUNIT,
                                         QTPREVI_MATPRIMA(C_FILIAL.CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, C_ORDPROD.QTAPRODPREOP) QTDE,
                                         (QTPREVI_MATPRIMA(C_FILIAL.CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, C_ORDPROD.QTAPRODPREOP) * CUSTO_PRODUTO(C_FILIAL.CDFILIAL, I.CDPRODINSUMO, C_FILIAL.NRTPCUSTOOP, SYSDATE, SYSDATE)) AS VRCUSTPLAN
                                    FROM INSUMETAPA I
                                   WHERE (I.CDFILIAL     = C_FILIAL.CDFILIAL)
                                     AND (I.CDPRODUTO    = C_ORDPROD.CDPRODUTO)
                                     AND (I.CDPROCFABRIC = C_ORDPROD.CDPROCFABRIC)
                                     AND (I.CDETAPAPROD  = C_ORDPROD.CDETAPAPROD)
                                     AND (C_ORDPROD.CDFUNCUSTO    = '001')
                                   UNION
                                  SELECT R.CDEQUIPPRO   AS CDAPRCUSTO,
                                         E.VRCUSTOEQUIP AS CUSTUNIT,
                                         R.QTHRUTRECUR AS QTDE,
                                         SUM(R.QTHRUTRECUR * E.VRCUSTOEQUIP) VRCUSTO
                                    FROM RECURETAPA R, EQUIPAPROD E
                                   WHERE (R.CDFILIAL     = C_FILIAL.CDFILIAL)
                                     AND (R.CDPRODUTO    = C_ORDPROD.CDPRODUTO)
                                     AND (R.CDPROCFABRIC = C_ORDPROD.CDPROCFABRIC)
                                     AND (R.CDETAPAPROD  = C_ORDPROD.CDETAPAPROD)
                                     AND (R.IDRECURETAPA = 'E')
                                     AND (R.CDEQUIPPRO   = E.CDEQUIPPRO)
                                     AND (C_ORDPROD.CDFUNCUSTO    = '003')
                                   GROUP BY R.CDEQUIPPRO, E.VRCUSTOEQUIP, R.QTHRUTRECUR
                                   UNION
                                  SELECT B.CDAPRCUSTO,
                                         B.VRCUSTOINSP AS CUSTUNIT,
                                         B.QTDE,
                                         (B.QTDE * B.VRCUSTOINSP) AS VRCUSTO
                                    FROM (SELECT I.CDINSPECAO AS CDAPRCUSTO,
                                                 INSP.VRCUSTOINSP,
                                                 COUNT(I.CDINSPECAO) AS QTDE
                                            FROM INSPECAO INSP, INSPETAPA I
                                           WHERE (I.CDFILIAL        = C_FILIAL.CDFILIAL)
                                             AND (I.CDPRODUTO       = C_ORDPROD.CDPRODUTO)
                                             AND (I.CDPROCFABRIC    = C_ORDPROD.CDPROCFABRIC)
                                             AND (I.CDETAPAPROD     = C_ORDPROD.CDETAPAPROD)
                                             AND (I.CDINSPECAO      = INSP.CDINSPECAO)
                                             AND (INSP.IDORIGINSPEC = 'ANA')
                                             AND (C_ORDPROD.CDFUNCUSTO = '004')
                                           GROUP BY I.CDINSPECAO, INSP.VRCUSTOINSP) B
                                           UNION
                                          SELECT C.CDAPRCUSTO,
                                                 C.VRCUSTOINSP AS CUSTUNIT,
                                                 C.QTDE,
                                                 (C.QTDE * C.VRCUSTOINSP) AS VRCUSTO
                                            FROM (SELECT I.CDINSPECAO AS CDAPRCUSTO,
                                                         INSP.VRCUSTOINSP,
                                                         COUNT(I.CDINSPECAO) AS QTDE
                                                    FROM INSPECAO INSP, INSPETAPA I
                                                   WHERE (I.CDFILIAL        = C_FILIAL.CDFILIAL)
                                                     AND (I.CDPRODUTO       = C_ORDPROD.CDPRODUTO)
                                                     AND (I.CDPROCFABRIC    = C_ORDPROD.CDPROCFABRIC)
                                                     AND (I.CDETAPAPROD     = C_ORDPROD.CDETAPAPROD)
                                                     AND (I.CDINSPECAO      = INSP.CDINSPECAO)
                                                     AND (INSP.IDORIGINSPEC = 'QUA')
                                                     AND (C_ORDPROD.CDFUNCUSTO       = '005')
                                                     GROUP BY I.CDINSPECAO, INSP.VRCUSTOINSP) C) PLAN,

                                 (SELECT A.CDAPRCUSTOP AS CDAPRCUSTO,
                                         SUM(DECODE(A.CDFUNCUSTO, '002',A.QTHRAPRCUST, '003', A.QTHRAPRCUST, A.QTAPRCUSTOP)) AS QTDE,
                                         SUM(DECODE(A.CDFUNCUSTO, '002', A.VRAPRCUSTOP * A.QTHRAPRCUST, '003', A.VRAPRCUSTOP * A.QTHRAPRCUST, A.QTAPRCUSTOP * A.VRAPRCUSTOP)) VRCUSTREAL
                                    FROM APRCUSTOP A
                                   WHERE (A.CDFILIAL     = C_FILIAL.CDFILIAL)
                                     AND (A.NRORDPROD    = C_ORDPROD.NRORDPROD)
                                     AND (A.NRSUBORDPROD = C_ORDPROD.NRSUBORDPROD)
                                     AND (A.CDETAPAPROD  = C_ORDPROD.CDETAPAPROD)
                                     AND (A.CDCUSTOINDI  = C_ORDPROD.CDCUSTOINDI)
                                   GROUP BY A.CDAPRCUSTOP) REAL

                          WHERE (DADOS.CDAPRCUSTO = PLAN.CDAPRCUSTO (+))
                            AND (DADOS.CDAPRCUSTO   = REAL.CDAPRCUSTO (+))
                          ORDER BY DADOS.CDAPRCUSTO)LOOP

         INSERT INTO DM_PROCFABPROD(
                                    --DIMENSAO
                                    CDANOBI,        --ANO
                                    CDMESBI,        --MES
                                    CDEMPRESA,      --EMPRESA
                                    DSFILIAL,       --FILIAL
                                    DSPRODUTO,      --PRODUTO+UNIDADE
                                    DSORDPROD,      --NRORDPROD+SUBORDPROD
                                    DSSITORDPROD,   --SITUACAO DA ORDEM DE PRODUCAO
                                    DSTIPOCUST,     --TIPO DE CUSTO DA ORDEM DE PRODUCAO
                                    DSETAPA,        --ETAPAS DA ORDEM DE PRODUCAO
                                    DSITEM,         --ITEM DA ORDEM DE PRODUCAO
                                    --FATOS
                                    VRCUSUNIT,      --CUSTO UNITARIO
                                    VRCUSPLAN,      --CUSTO PLANEJADO
                                    VRCUSREAL,      --CUSTO REALIZADO
                                    QTDEPLAN,       --QUANTIDADE PLANEJADA(TEMPO OU QUANTIDADE(Quando for materia prima))
                                    QTDEREAL        --QUANTIDADE REALIZADA(TEMPO OU QUANTIDADE(Quando for materia prima))
                                    )
                            VALUES(
                                   --DIMENSAO
                                   C_DATA.CDANOBI,
                                   C_DATA.CDMESBI,
                                   C_FILIAL.CDEMPRESA,
                                   C_FILIAL.DSFILIAL,
                                   C_ORDPROD.DSPRODUTO,
                                   C_ORDPROD.DSORDPROD,
                                   C_ORDPROD.DSSITORDPROD,
                                   C_ORDPROD.NMCUSTOINDI,
                                   C_ORDPROD.NMETAPAPROD,
                                   C_CUSTO.NMAPRCUSTO,
                                   --FATOS
                                   C_CUSTO.CUSTUNIT,
                                   C_CUSTO.VRCUSTPLAN,
                                   C_CUSTO.VRCUSTREAL,
                                   C_CUSTO.QTDEPLAN,
                                   C_CUSTO.QTDEREAL
                                   );
                                   COMMIT;
            END LOOP;--FIM DO C_CUSTO
          END LOOP;--FIM DO C_ORDPROD
        END LOOP;--FIM DO C_FILIAL
      END LOOP;--FIM DO C_DATA
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('ETL_ORDPRODUCAO','5.30.000'); END;
/

--BLOCO DE AUTO-COFIGURAO DE FATOS E DIMENSES
BEGIN
   --FATOS--
      CRIA_FATOS('DM_PROCFABPROD',   'VRCUSUNIT', 'Custo Uni.',        'Custo Unitrio',                           'Processo de Fabricao');
      CRIA_FATOS('DM_PROCFABPROD',   'VRCUSPLAN', 'Custo Plan.',       'Custo Planejado',                          'Processo de Fabricao');
      CRIA_FATOS('DM_PROCFABPROD',   'VRCUSREAL', 'Custo Real.',       'Custo Realizado',                          'Processo de Fabricao');
      CRIA_FATOS('DM_PROCFABPROD',   'QTDEPLAN',  'Quant/Tempo Plan.', 'Quantidade Planejada(TEMPO OU QUANTIDADE)','Processo de Fabricao');
      CRIA_FATOS('DM_PROCFABPROD',   'QTDEREAL',  'Quant/Tempo Real.', 'Quantidade Realizada(TEMPO OU QUANTIDADE)','Processo de Fabricao');
      
      --DIMENSES
      CRIA_DIME('DM_PROCFABPROD', 'CDANOBI',       'Ano',             NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'CDMESBI',       'Ms',             NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'DSDESC',        'Descrio',       NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'DSTIPOCUST',    'Custo',           NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'DSETAPA',       'Etapa',           NULL,      NULL,        NULL,       NULL);    
      CRIA_DIME('DM_PROCFABPROD', 'DSFILIAL',      'Filial',          NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'DSSITORDPROD',  'Situao',        NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'DSPRODUTO',     'Produto',         NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'DSORDPROD',     'Nr. Ordem',       NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'DSITEM',        'Item',            NULL,      NULL,        NULL,       NULL);
      CRIA_DIME('DM_PROCFABPROD', 'CDEMPRESA',     'Empresa',         'EMPRESA',     'CDEMPRESA',        'NMEMPRESA',       '');
END;
/