/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_INDI                                                     */
/* Tabela : INDICE                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_INDI'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_INDI
GO

CREATE TRIGGER DTULTATU_INDI
ON INDICE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'INDICE', null, 'CDTPINDICE='+ CDTPINDICE+ ';'+
                                     'IDPERVALOR='+ IDPERVALOR+ ';'+
                                     'CDINDICE='  + CDINDICE  + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE INDICE
      SET DTULTATUINDI = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(INDICE.CDINDICE,0)   = ISNULL(INSERTED.CDINDICE,0))   AND
            (ISNULL(INDICE.SGINDICE,0)   = ISNULL(INSERTED.SGINDICE,0))   AND
            (ISNULL(INDICE.NMINDICE,0)   = ISNULL(INSERTED.NMINDICE,0))   AND
            (ISNULL(INDICE.CDTPINDICE,0) = ISNULL(INSERTED.CDTPINDICE,0)) AND
            (ISNULL(INDICE.IDPERVALOR,0) = ISNULL(INSERTED.IDPERVALOR,0));
   END;
END;
GO

