/* ======= Tabela COMPENSACONTPAG: Compensao de Contas a Pagar =======*/
/* ======= Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela COMPENSACONTPAG */
/* ======= Objetivo: Gerar um log que vai registrar as alteraes na tabela Compensao de Contas a Pagar,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIN_COMPENSACONTPAG' AND
                 TYPE   = 'TR' 		           AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIN_COMPENSACONTPAG
GO


CREATE TRIGGER LOG_FIN_COMPENSACONTPAG
ON COMPENSACONTPAG
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(500);
   DECLARE  @V_DTOPER       DATETIME;
   DECLARE  @V_DSREMOTEADDR VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST VARCHAR(15);
   DECLARE  @V_DSSERVERRDM  VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER VARCHAR(12);

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO    VARCHAR(1);

   DECLARE @V_OLD_CDEMPRESA       VARCHAR(2 );
   DECLARE @V_OLD_NRLANCCOMPPAG   VARCHAR(10);
   DECLARE @V_OLD_CDFILIAL        VARCHAR(4 );
   DECLARE @V_OLD_NRLANBOLPAG     VARCHAR(10);
   DECLARE @V_OLD_CDOPERLANCCOMCP VARCHAR(12);
   DECLARE @V_OLD_DTLANCCOMPPAG   DATETIME;
   DECLARE @V_OLD_CDFORNECED      VARCHAR(21);
   DECLARE @V_OLD_DTCOMPENCTPAG   DATETIME;
   DECLARE @V_OLD_CDTPBAIXAREC    VARCHAR(2 );
   DECLARE @V_OLD_CDTPBAIXAPAG    VARCHAR(2 );
   DECLARE @V_OLD_CDAJUCTREC      VARCHAR(4 );
   DECLARE @V_OLD_CDAJUCTPAG      VARCHAR(4 );
   DECLARE @V_OLD_CDREDUCONT      VARCHAR(3 );
   DECLARE @V_OLD_DTBAIXACOMP     DATETIME;
   DECLARE @V_OLD_CDFILIBAIXAREC  VARCHAR(4 );
   DECLARE @V_OLD_NRBAIXAREC      VARCHAR(10);
   DECLARE @V_OLD_CDFILIBAIXAPAG  VARCHAR(4 );
   DECLARE @V_OLD_NRBAIXAPAG      VARCHAR(10);
   DECLARE @V_OLD_IDTPITUTLCOMPAG VARCHAR( 1);
   DECLARE @V_OLD_QTITENSCOMPPAG  DOUBLE PRECISION;
   DECLARE @V_OLD_VRTOTALCOMPPAG  DOUBLE PRECISION;

   DECLARE @V_NEW_CDEMPRESA       VARCHAR(2 );
   DECLARE @V_NEW_NRLANCCOMPPAG   VARCHAR(10);
   DECLARE @V_NEW_CDFILIAL        VARCHAR(4 );
   DECLARE @V_NEW_NRLANBOLPAG     VARCHAR(10);
   DECLARE @V_NEW_CDOPERLANCCOMCP VARCHAR(12);
   DECLARE @V_NEW_DTLANCCOMPPAG   DATETIME;
   DECLARE @V_NEW_CDFORNECED      VARCHAR(21);
   DECLARE @V_NEW_DTCOMPENCTPAG   DATETIME;
   DECLARE @V_NEW_CDTPBAIXAREC    VARCHAR(2 );
   DECLARE @V_NEW_CDTPBAIXAPAG    VARCHAR(2 );
   DECLARE @V_NEW_CDAJUCTREC      VARCHAR(4 );
   DECLARE @V_NEW_CDAJUCTPAG      VARCHAR(4 );
   DECLARE @V_NEW_CDREDUCONT      VARCHAR(3 );
   DECLARE @V_NEW_DTBAIXACOMP     DATETIME;
   DECLARE @V_NEW_CDFILIBAIXAREC  VARCHAR(4 );
   DECLARE @V_NEW_NRBAIXAREC      VARCHAR(10);
   DECLARE @V_NEW_CDFILIBAIXAPAG  VARCHAR(4 );
   DECLARE @V_NEW_NRBAIXAPAG      VARCHAR(10);
   DECLARE @V_NEW_IDTPITUTLCOMPAG VARCHAR( 1);
   DECLARE @V_NEW_QTITENSCOMPPAG  DOUBLE PRECISION;
   DECLARE @V_NEW_VRTOTALCOMPPAG  DOUBLE PRECISION;
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER ;

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDEMPRESA,
         NRLANCCOMPPAG,
         CDFILIAL,
         NRLANBOLPAG,
         CDOPERLANCCOMCP,
         DTLANCCOMPPAG,
         CDFORNECED,
         DTCOMPENCTPAG,
         CDTPBAIXAREC,
         CDTPBAIXAPAG,
         CDAJUCTREC,
         CDAJUCTPAG,
         CDREDUCONT,
         DTBAIXACOMP,
         CDFILIBAIXAREC,
         NRBAIXAREC,
         CDFILIBAIXAPAG,
         NRBAIXAPAG,
         IDTPITUTLCOMPAG,
         QTITENSCOMPPAG,
         VRTOTALCOMPPAG,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
     DELETED
   WHERE
     CDEMPRESA+NRLANCCOMPPAG NOT IN (SELECT CDEMPRESA+NRLANCCOMPPAG FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
         DELETED.CDEMPRESA,
         DELETED.NRLANCCOMPPAG,
         DELETED.CDFILIAL,
         DELETED.NRLANBOLPAG,
         DELETED.CDOPERLANCCOMCP,
         DELETED.DTLANCCOMPPAG,
         DELETED.CDFORNECED,
         DELETED.DTCOMPENCTPAG,
         DELETED.CDTPBAIXAREC,
         DELETED.CDTPBAIXAPAG,
         DELETED.CDAJUCTREC,
         DELETED.CDAJUCTPAG,
         DELETED.CDREDUCONT,
         DELETED.DTBAIXACOMP,
         DELETED.CDFILIBAIXAREC,
         DELETED.NRBAIXAREC,
         DELETED.CDFILIBAIXAPAG,
         DELETED.NRBAIXAPAG,
         DELETED.IDTPITUTLCOMPAG,
         DELETED.QTITENSCOMPPAG,
         DELETED.VRTOTALCOMPPAG,

         INSERTED.CDEMPRESA,
         INSERTED.NRLANCCOMPPAG,
         INSERTED.CDFILIAL,
         INSERTED.NRLANBOLPAG,
         INSERTED.CDOPERLANCCOMCP,
         INSERTED.DTLANCCOMPPAG,
         INSERTED.CDFORNECED,
         INSERTED.DTCOMPENCTPAG,
         INSERTED.CDTPBAIXAREC,
         INSERTED.CDTPBAIXAPAG,
         INSERTED.CDAJUCTREC,
         INSERTED.CDAJUCTPAG,
         INSERTED.CDREDUCONT,
         INSERTED.DTBAIXACOMP,
         INSERTED.CDFILIBAIXAREC,
         INSERTED.NRBAIXAREC,
         INSERTED.CDFILIBAIXAPAG,
         INSERTED.NRBAIXAPAG,
         INSERTED.IDTPITUTLCOMPAG,
         INSERTED.QTITENSCOMPPAG,
         INSERTED.VRTOTALCOMPPAG
   FROM
       INSERTED,
       DELETED
    WHERE
       (INSERTED.CDEMPRESA+INSERTED.NRLANCCOMPPAG) =
       (DELETED.CDEMPRESA+DELETED.NRLANCCOMPPAG)

    UNION ALL

    SELECT
       'I' IDCOMANDO,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,

           INSERTED.CDEMPRESA,
           INSERTED.NRLANCCOMPPAG,
           INSERTED.CDFILIAL,
           INSERTED.NRLANBOLPAG,
           INSERTED.CDOPERLANCCOMCP,
           INSERTED.DTLANCCOMPPAG,
           INSERTED.CDFORNECED,
           INSERTED.DTCOMPENCTPAG,
           INSERTED.CDTPBAIXAREC,
           INSERTED.CDTPBAIXAPAG,
           INSERTED.CDAJUCTREC,
           INSERTED.CDAJUCTPAG,
           INSERTED.CDREDUCONT,
           INSERTED.DTBAIXACOMP,
           INSERTED.CDFILIBAIXAREC,
           INSERTED.NRBAIXAREC,
           INSERTED.CDFILIBAIXAPAG,
           INSERTED.NRBAIXAPAG,
           INSERTED.IDTPITUTLCOMPAG,
           INSERTED.QTITENSCOMPPAG,
           INSERTED.VRTOTALCOMPPAG

    FROM
      INSERTED
    WHERE
     CDEMPRESA+NRLANCCOMPPAG NOT IN (SELECT CDEMPRESA+NRLANCCOMPPAG FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDEMPRESA,
                                 @V_OLD_NRLANCCOMPPAG,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_NRLANBOLPAG,
                                 @V_OLD_CDOPERLANCCOMCP,
                                 @V_OLD_DTLANCCOMPPAG,
                                 @V_OLD_CDFORNECED,
                                 @V_OLD_DTCOMPENCTPAG,
                                 @V_OLD_CDTPBAIXAREC,
                                 @V_OLD_CDTPBAIXAPAG,
                                 @V_OLD_CDAJUCTREC,
                                 @V_OLD_CDAJUCTPAG,
                                 @V_OLD_CDREDUCONT,
                                 @V_OLD_DTBAIXACOMP,
                                 @V_OLD_CDFILIBAIXAREC,
                                 @V_OLD_NRBAIXAREC,
                                 @V_OLD_CDFILIBAIXAPAG,
                                 @V_OLD_NRBAIXAPAG,
                                 @V_OLD_IDTPITUTLCOMPAG,
                                 @V_OLD_QTITENSCOMPPAG,
                                 @V_OLD_VRTOTALCOMPPAG,


                                 @V_NEW_CDEMPRESA,
                                 @V_NEW_NRLANCCOMPPAG,
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_NRLANBOLPAG,
                                 @V_NEW_CDOPERLANCCOMCP,
                                 @V_NEW_DTLANCCOMPPAG,
                                 @V_NEW_CDFORNECED,
                                 @V_NEW_DTCOMPENCTPAG,
                                 @V_NEW_CDTPBAIXAREC,
                                 @V_NEW_CDTPBAIXAPAG,
                                 @V_NEW_CDAJUCTREC,
                                 @V_NEW_CDAJUCTPAG,
                                 @V_NEW_CDREDUCONT,
                                 @V_NEW_DTBAIXACOMP,
                                 @V_NEW_CDFILIBAIXAREC,
                                 @V_NEW_NRBAIXAREC,
                                 @V_NEW_CDFILIBAIXAPAG,
                                 @V_NEW_NRBAIXAPAG,
                                 @V_NEW_IDTPITUTLCOMPAG,
                                 @V_NEW_QTITENSCOMPPAG,
                                 @V_NEW_VRTOTALCOMPPAG;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN /*DELETING*/

         IF @V_OLD_CDEMPRESA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdEmp=' + @V_OLD_CDEMPRESA;
         END;

         IF @V_OLD_NRLANCCOMPPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NroComp=' + @V_OLD_NRLANCCOMPPAG;
         END;

         IF (@V_OLD_CDFILIAL IS NOT NULL) AND (@V_OLD_NRLANBOLPAG IS NOT NULL) BEGIN
            SET @V_DESC = @V_DESC + ' ChaveBol=' + @V_OLD_CDFILIAL + @V_OLD_NRLANBOLPAG;
         END;

         IF @V_OLD_CDOPERLANCCOMCP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdOpLanc=' + @V_OLD_CDOPERLANCCOMCP;
         END;

         IF @V_OLD_DTLANCCOMPPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtLancC=' + CONVERT(VARCHAR, @V_OLD_DTLANCCOMPPAG, 103);
         END;

         IF @V_OLD_CDFORNECED IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdForn=' + @V_OLD_CDFORNECED;
         END;

         IF @V_OLD_DTCOMPENCTPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtCompPag=' + CONVERT(VARCHAR, @V_OLD_DTCOMPENCTPAG, 103);
         END;

         IF @V_OLD_CDTPBAIXAREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpBxRec=' + @V_OLD_CDTPBAIXAREC;
         END;

         IF @V_OLD_CDTPBAIXAPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpBxPag=' + @V_OLD_CDTPBAIXAPAG;
         END;

         IF @V_OLD_CDAJUCTREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpAjRec=' +  @V_OLD_CDAJUCTREC;
         END;

         IF @V_OLD_CDAJUCTPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpAjPag=' +  @V_OLD_CDAJUCTPAG;
         END;

         IF @V_OLD_CDREDUCONT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdReCont=' + @V_OLD_CDREDUCONT;
         END;

         IF @V_OLD_DTBAIXACOMP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtBxComp=' + CONVERT(VARCHAR, @V_OLD_DTBAIXACOMP, 103);
         END;

         IF (@V_OLD_CDFILIBAIXAREC IS NOT NULL) AND (@V_OLD_NRBAIXAREC IS NOT NULL) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxRec=' + @V_OLD_CDFILIBAIXAREC + @V_OLD_NRBAIXAREC;
         END;

         IF (@V_OLD_CDFILIBAIXAPAG IS NOT NULL) AND (@V_OLD_NRBAIXAPAG IS NOT NULL) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxPag=' + @V_OLD_CDFILIBAIXAPAG + @V_OLD_NRBAIXAPAG;
         END;

         IF @V_OLD_IDTPITUTLCOMPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdItem=' + @V_OLD_IDTPITUTLCOMPAG;
         END;

         IF @V_OLD_QTITENSCOMPPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' QtItens=' + CONVERT(VARCHAR, @V_OLD_QTITENSCOMPPAG);
         END;

         IF @V_OLD_VRTOTALCOMPPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrComp=' + CONVERT(VARCHAR, @V_OLD_VRTOTALCOMPPAG);
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDEMPRESA + @V_OLD_NRLANCCOMPPAG;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' BEGIN /*UPDATING*/
            IF (ISNULL(@V_OLD_CDEMPRESA,       '0') <> ISNULL(@V_NEW_CDEMPRESA,       '0')) OR
               (ISNULL(@V_OLD_NRLANCCOMPPAG,   '0') <> ISNULL(@V_NEW_NRLANCCOMPPAG,   '0')) OR
               (ISNULL(@V_OLD_CDFILIAL,        '0') <> ISNULL(@V_NEW_CDFILIAL,        '0')) OR
               (ISNULL(@V_OLD_NRLANBOLPAG,     '0') <> ISNULL(@V_NEW_NRLANBOLPAG,     '0')) OR
               (ISNULL(@V_OLD_CDOPERLANCCOMCP, '0') <> ISNULL(@V_NEW_CDOPERLANCCOMCP, '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_DTLANCCOMPPAG, 103),   '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTLANCCOMPPAG, 103),   '0')) OR
               (ISNULL(@V_OLD_CDFORNECED,      '0') <> ISNULL(@V_NEW_CDFORNECED,      '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_DTCOMPENCTPAG, 103),   '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTCOMPENCTPAG, 103),   '0')) OR
               (ISNULL(@V_OLD_CDTPBAIXAREC,    '0') <> ISNULL(@V_NEW_CDTPBAIXAREC,    '0')) OR
               (ISNULL(@V_OLD_CDTPBAIXAPAG,    '0') <> ISNULL(@V_NEW_CDTPBAIXAPAG,    '0')) OR
               (ISNULL(@V_OLD_CDAJUCTREC,      '0') <> ISNULL(@V_NEW_CDAJUCTREC,     '0')) OR
               (ISNULL(@V_OLD_CDAJUCTPAG,      '0') <> ISNULL(@V_NEW_CDAJUCTPAG,     '0')) OR
               (ISNULL(@V_OLD_CDREDUCONT,      '0') <> ISNULL(@V_NEW_CDREDUCONT,      '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_DTBAIXACOMP, 103),     '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTBAIXACOMP, 103),     '0')) OR
               (ISNULL(@V_OLD_CDFILIBAIXAREC,  '0') <> ISNULL(@V_NEW_CDFILIBAIXAREC,  '0')) OR
               (ISNULL(@V_OLD_NRBAIXAREC,      '0') <> ISNULL(@V_NEW_NRBAIXAREC,      '0')) OR
               (ISNULL(@V_OLD_CDFILIBAIXAPAG,  '0') <> ISNULL(@V_OLD_CDFILIBAIXAPAG,  '0')) OR
               (ISNULL(@V_OLD_NRBAIXAPAG,      '0') <> ISNULL(@V_NEW_NRBAIXAPAG,      '0')) OR
               (ISNULL(@V_OLD_IDTPITUTLCOMPAG, '0') <> ISNULL(@V_NEW_IDTPITUTLCOMPAG, '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_QTITENSCOMPPAG),  '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_QTITENSCOMPPAG),  '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_VRTOTALCOMPPAG),  '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_VRTOTALCOMPPAG),  '0')) BEGIN

                SET @V_ITPESQ = @V_OLD_CDEMPRESA + @V_OLD_NRLANCCOMPPAG;
                SET @V_TIPO   = '2';
            END;
         END
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDEMPRESA + @V_NEW_NRLANCCOMPPAG;
         END;
         IF ISNULL(@V_OLD_CDEMPRESA, '0') <> ISNULL(@V_NEW_CDEMPRESA, '0') BEGIN
            SET @V_DESC = @V_DESC + 'CdEmp=' + @V_NEW_CDEMPRESA;
         END;

         IF ISNULL(@V_OLD_NRLANCCOMPPAG,'0') <>  ISNULL(@V_NEW_NRLANCCOMPPAG,'0') BEGIN
            SET @V_DESC = @V_DESC + ' NroComp=' + @V_NEW_NRLANCCOMPPAG;
         END;

         IF (ISNULL(@V_OLD_CDFILIAL, '0') <> ISNULL(@V_NEW_CDFILIAL, '0')) OR
            (ISNULL(@V_OLD_NRLANBOLPAG,'0') <>  ISNULL(@V_NEW_NRLANBOLPAG,'0')) BEGIN
            SET @V_DESC = @V_DESC + ' ChaveBol=' + @V_NEW_CDFILIAL + @V_NEW_NRLANBOLPAG;
         END;

         IF ISNULL(@V_OLD_CDOPERLANCCOMCP,'0') <> ISNULL(@V_NEW_CDOPERLANCCOMCP, '0') BEGIN
            SET @V_DESC = @V_DESC + ' CdOpLanc=' + @V_NEW_CDOPERLANCCOMCP;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_DTLANCCOMPPAG, 103), '0') <> ISNULL(CONVERT(VARCHAR,@V_NEW_DTLANCCOMPPAG, 103), '0') BEGIN
            SET @V_DESC = @V_DESC + ' DtLancC=' + CONVERT(VARCHAR, @V_NEW_DTLANCCOMPPAG, 103);
         END;

         IF ISNULL(@V_OLD_CDFORNECED, '0') <>  ISNULL(@V_NEW_CDFORNECED, '0') BEGIN
            SET @V_DESC = @V_DESC + ' CdForn=' + @V_NEW_CDFORNECED;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_DTCOMPENCTPAG, 103), '0') <> ISNULL(CONVERT(VARCHAR,@V_NEW_DTCOMPENCTPAG, 103), '0') BEGIN
            SET @V_DESC = @V_DESC + ' DtCompPag=' + CONVERT(VARCHAR, @V_NEW_DTCOMPENCTPAG, 103);
         END;

         IF ISNULL(@V_OLD_CDTPBAIXAREC, '0') <> ISNULL(@V_NEW_CDTPBAIXAREC, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpBxRec=' + @V_NEW_CDTPBAIXAREC;
         END;

         IF ISNULL(@V_OLD_CDTPBAIXAPAG, '0') <> ISNULL(@V_NEW_CDTPBAIXAPAG, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpBxPag=' + @V_NEW_CDTPBAIXAPAG;
         END;

         IF ISNULL(@V_OLD_CDAJUCTREC, '0') <> ISNULL(@V_NEW_CDAJUCTREC, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpAjRec=' +  @V_NEW_CDAJUCTREC;
         END;

         IF ISNULL(@V_OLD_CDAJUCTPAG, '0') <> ISNULL(@V_NEW_CDAJUCTPAG, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpAjPag=' +  @V_NEW_CDAJUCTPAG;
         END;

         IF ISNULL(@V_OLD_CDREDUCONT, '0') <> ISNULL(@V_NEW_CDREDUCONT, '0') BEGIN
            SET @V_DESC = @V_DESC + ' CdReCont=' + @V_NEW_CDREDUCONT;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_DTBAIXACOMP, 103), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTBAIXACOMP, 103), '0') BEGIN
            SET @V_DESC = @V_DESC + ' DtBxComp=' + CONVERT(VARCHAR, @V_NEW_DTBAIXACOMP, 103);
         END;

         IF (ISNULL(@V_OLD_CDFILIBAIXAREC, '0') <> ISNULL(@V_NEW_CDFILIBAIXAREC, '0')) OR
            (ISNULL(@V_OLD_NRBAIXAREC, '0') <> ISNULL(@V_NEW_NRBAIXAREC, '0')) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxRec=' + @V_NEW_CDFILIBAIXAREC + @V_NEW_NRBAIXAREC;
         END;

         IF (ISNULL(@V_OLD_CDFILIBAIXAPAG, '0') <> ISNULL(@V_NEW_CDFILIBAIXAPAG, '0')) OR
            (ISNULL(@V_OLD_NRBAIXAPAG, '0') <>  ISNULL(@V_NEW_NRBAIXAPAG, '0')) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxPag=' + @V_NEW_CDFILIBAIXAPAG + @V_NEW_NRBAIXAPAG;
         END;

         IF ISNULL(@V_OLD_IDTPITUTLCOMPAG, '0') <> ISNULL(@V_NEW_IDTPITUTLCOMPAG, '0') BEGIN
            SET @V_DESC = @V_DESC + ' IdItem=' + @V_NEW_IDTPITUTLCOMPAG;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_QTITENSCOMPPAG), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_QTITENSCOMPPAG), '0') BEGIN
            SET @V_DESC = @V_DESC + ' QtItens=' + CONVERT(VARCHAR, @V_NEW_QTITENSCOMPPAG);
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_VRTOTALCOMPPAG), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_VRTOTALCOMPPAG), '0') BEGIN
            SET @V_DESC = @V_DESC + ' VrComp=' + CONVERT(VARCHAR, @V_NEW_VRTOTALCOMPPAG);
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL AND @V_DESC <> '' BEGIN
            EXEC NMUSUARIO @V_USUARIO;
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('COMPENSACONTPAG',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO, @V_ITPESQ, @V_DESC, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM,
                   @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDEMPRESA,
                                    @V_OLD_NRLANCCOMPPAG,
                                    @V_OLD_CDFILIAL,
                                    @V_OLD_NRLANBOLPAG,
                                    @V_OLD_CDOPERLANCCOMCP,
                                    @V_OLD_DTLANCCOMPPAG,
                                    @V_OLD_CDFORNECED,
                                    @V_OLD_DTCOMPENCTPAG,
                                    @V_OLD_CDTPBAIXAREC,
                                    @V_OLD_CDTPBAIXAPAG,
                                    @V_OLD_CDAJUCTREC,
                                    @V_OLD_CDAJUCTPAG,
                                    @V_OLD_CDREDUCONT,
                                    @V_OLD_DTBAIXACOMP,
                                    @V_OLD_CDFILIBAIXAREC,
                                    @V_OLD_NRBAIXAREC,
                                    @V_OLD_CDFILIBAIXAPAG,
                                    @V_OLD_NRBAIXAPAG,
                                    @V_OLD_IDTPITUTLCOMPAG,
                                    @V_OLD_QTITENSCOMPPAG,
                                    @V_OLD_VRTOTALCOMPPAG,

                                    @V_NEW_CDEMPRESA,
                                    @V_NEW_NRLANCCOMPPAG,
                                    @V_NEW_CDFILIAL,
                                    @V_NEW_NRLANBOLPAG,
                                    @V_NEW_CDOPERLANCCOMCP,
                                    @V_NEW_DTLANCCOMPPAG,
                                    @V_NEW_CDFORNECED,
                                    @V_NEW_DTCOMPENCTPAG,
                                    @V_NEW_CDTPBAIXAREC,
                                    @V_NEW_CDTPBAIXAPAG,
                                    @V_NEW_CDAJUCTREC,
                                    @V_NEW_CDAJUCTPAG,
                                    @V_NEW_CDREDUCONT,
                                    @V_NEW_DTBAIXACOMP,
                                    @V_NEW_CDFILIBAIXAREC,
                                    @V_NEW_NRBAIXAREC,
                                    @V_NEW_CDFILIBAIXAPAG,
                                    @V_NEW_NRBAIXAPAG,
                                    @V_NEW_IDTPITUTLCOMPAG,
                                    @V_NEW_QTITENSCOMPPAG,
                                    @V_NEW_VRTOTALCOMPPAG;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIN_COMPENSACONTPAG','5.50.xxx';
GO

